/* This file is part of dengue: Dengue fever individual propagation model
Copyright (C) 2012 Harish Padmanabha, Fabio Correa

This project has been developed by Harish Padmanabha<harishpadmanabha@gmail.com> and Fabio Correa<facorread@gmail.com>
This code has been delivered to the Public Library of Science, on February 16, 2015.
We, the developers, grant you a license to review and modify this source code for your own use.
We do not grant you license to distribute or publish this program or any derivative work, any of its output, the ideas or algorithms contained within, in any form.
Anybody who wishes to get a copy of this source code or to get this project under a different license should email the developers directly.

*/

using namespace std;

/// Identifies an object
class idCls {
	private:
		/// Identifies the object
		int mID;
	public:
		idCls(const int ID) : mID(ID) {}
		/// Returns the identification of the object
		int id() const { return mID; }
		/// Returns the index of the object, for use in arrays / vectors.
		int index() const { return mID; }
};

/// Identifies the index of an object, for use in arrays / vectors.
class indexCls : public idCls {
	private:
		/// Identifies the index of the object, for use in arrays / vectors.
		int mIndex;
	public:
		indexCls(int ID, int index) : idCls(ID), mIndex(index) {}
		/// Returns the index of the object, for use in arrays / vectors.
		int index() const { return mIndex; }
};
